## samba 4.15.13+dfsg

=== ctdb/Makefile ===
# simple makefile wrapper to run waf

WAF_BINARY=$(PYTHON) ../buildtools/bin/waf
WAF=WAF_MAKE=1 $(WAF_BINARY)

all:
	$(WAF) build

install:
	$(WAF) install

uninstall:
	$(WAF) uninstall

test: FORCE
	$(WAF) test $(TEST_OPTIONS)

testenv:
	$(WAF) test --testenv $(TEST_OPTIONS)

autotest:
	$(WAF) autotest $(TEST_OPTIONS)

quicktest:
	$(WAF) test --quick $(TEST_OPTIONS)

show_version:
	@touch .tmplock
	@WAFLOCK=.tmplock $(WAF) show_version

manpages:
	touch .tmplock
	WAFLOCK=.tmplock $(WAF) manpages

dist:
	touch .tmplock
	WAFLOCK=.tmplock $(WAF) dist

distcheck:
	touch .tmplock
	WAFLOCK=.tmplock $(WAF) distcheck

rpm:
	touch .tmplock
	WAFLOCK=.tmplock $(WAF) rpm

clean:
	$(WAF) clean

distclean:
	$(WAF) distclean

reconfigure: configure
	$(WAF) reconfigure

show_waf_options:
	$(WAF) --help

# some compatibility make targets
everything: all

testsuite: all

check: test

torture: all

# this should do an install as well, once install is finished
installcheck: test

etags:
	$(WAF) etags

ctags:
	touch .tmplock
	WAFLOCK=.tmplock $(WAF) ctags

pydoctor:
	$(WAF) pydoctor

bin/%:: FORCE
	$(WAF) --targets=`basename $@`
FORCE:

=== selftest/wscript ===
#!/usr/bin/env python
# vim: expandtab ft=python

# selftest main code.

import sys
import os
import optparse
from waflib import Scripting, Options, Utils
from waflib.ConfigSet import ConfigSet as Environment

from samba_utils import *
from samba_autoconf import *
import types

DEFAULT_SELFTEST_PREFIX="./st"

def options(opt):

    opt.add_option('--enable-selftest',
                   help=("enable options necessary for selftest (default=no)"),
                   action="store_true", dest='enable_selftest', default=False)
    opt.add_option('--with-selftest-prefix',
                   help=("specify location of selftest directory "
                         "(default=%s)" % DEFAULT_SELFTEST_PREFIX),
                   action="store", dest='SELFTEST_PREFIX', default=DEFAULT_SELFTEST_PREFIX)

    opt.ADD_COMMAND('test', cmd_test)
    opt.ADD_COMMAND('testonly', cmd_testonly)

    gr = opt.add_option_group('test options')

    gr.add_option('--load-list',
                  help=("Load a test id list from a text file"),
                  action="store", dest='LOAD_LIST', default=None)
    gr.add_option('--list',
                  help=("List available tests"),
                  action="store_true", dest='LIST', default=False)
    gr.add_option('--tests',
                  help=("wildcard pattern of tests to run"),
                  action="store", dest='TESTS', default='')
    gr.add_option('--filtered-subunit',
                  help=("output (xfail) filtered subunit"),
                  action="store_true", dest='FILTERED_SUBUNIT', default=False)
    gr.add_option('--quick',
                  help=("enable only quick tests"),
                  action="store_true", dest='QUICKTEST', default=False)
    gr.add_option('--slow',
                  help=("enable the really slow tests"),
                  action="store_true", dest='SLOWTEST', default=False)
    gr.add_option('--nb-slowest',
                  help=("Show the n slowest tests (default=10)"),
                  type=int, default=10, dest='NB_SLOWEST')
    gr.add_option('--testenv',
                  help=("start a terminal with the test environment setup"),
                  action="store_true", dest='TESTENV', default=False)
    gr.add_option('--valgrind',
                  help=("use valgrind on client programs in the tests"),
                  action="store_true", dest='VALGRIND', default=False)
    gr.add_option('--valgrind-log',
                  help=("where to put the valgrind log"),
                  action="store", dest='VALGRINDLOG', default=None)
    gr.add_option('--valgrind-server',
                  help=("use valgrind on the server in the tests (opens an xterm)"),
                  action="store_true", dest='VALGRIND_SERVER', default=False)
    gr.add_option('--screen',
                  help=("run the samba servers in screen sessions"),
                  action="store_true", dest='SCREEN', default=False)
    gr.add_option('--gdbtest',
                  help=("run the servers within a gdb window"),
                  action="store_true", dest='GDBTEST', default=False)
    gr.add_option('--fail-immediately',
                  help=("stop tests on first failure"),
                  action="store_true", dest='FAIL_IMMEDIATELY', default=False)
    gr.add_option('--socket-wrapper-pcap',
                  help=("create a pcap file for each failing test"),
                  action="store_true", dest='SOCKET_WRAPPER_PCAP', default=False)
    gr.add_option('--socket-wrapper-keep-pcap',
                  help=("create a pcap file for all individual test"),
                  action="store_true", dest='SOCKET_WRAPPER_KEEP_PCAP', default=False)
    gr.add_option('--random-order', dest='RANDOM_ORDER', default=False,
                  action="store_true", help="Run testsuites in random order")
    gr.add_option('--perf-test', dest='PERF_TEST', default=False,
                  action="store_true", help="run performance tests only")
    gr.add_option('--test-list', dest='TEST_LIST', default='',
                  help=("use tests listed here, not defaults "
                        "(--test-list='FOO|' will execute FOO; "
                        "--test-list='FOO' will read it)"))
    gr.add_option('--no-subunit-filter',
                  help=("no (xfail) subunit filtering"),
                  action="store_true", dest='NO_SUBUNIT_FILTER', default=False)


def configure(conf):
    conf.env.SELFTEST_PREFIX = Options.options.SELFTEST_PREFIX
    if Options.options.enable_selftest or Options.options.developer:
        conf.DEFINE('ENABLE_SELFTEST', 1)


def cmd_testonly(opt):
    '''run tests without doing a build first'''
    env = LOAD_ENVIRONMENT()
    opt.env = env

    if Options.options.SELFTEST_PREFIX != DEFAULT_SELFTEST_PREFIX:
        env.SELFTEST_PREFIX = Options.options.SELFTEST_PREFIX

    if (not CONFIG_SET(opt, 'NSS_WRAPPER') or
        not CONFIG_SET(opt, 'UID_WRAPPER') or
        not CONFIG_SET(opt, 'SOCKET_WRAPPER')):
        print("ERROR: You must use --enable-selftest to enable selftest")
        sys.exit(1)

    os.environ['SAMBA_SELFTEST'] = '1'

    env.TESTS  = Options.options.TESTS

    env.SUBUNIT_FORMATTER = os.getenv('SUBUNIT_FORMATTER')

    # Lots of test scripts need to run with the correct version
    # of python. With the correct shebang the script should run with the
    # correct version, the problem is that not all scripts are part
    # of the installation, some scripts are part of the source code,
    # and the shebang is not dynamically generated as yet.
    # It is safer if we are somewhat version neutral at the moment and
    # ignore the shebang and always run scripts from the test environment
    # with the python version (determined by PYTHON env variable) If this
    # env variable isn't set then set it according to the python version
    # that is running the tests
    if not os.getenv('PYTHON', None):
        from sys import executable as exe
        os.environ['PYTHON'] = os.path.basename(exe)

    if not env.SUBUNIT_FORMATTER:
        if Options.options.PERF_TEST:
            env.SUBUNIT_FORMATTER = '${PYTHON} -u ${srcdir}/selftest/format-subunit-json --prefix=${SELFTEST_PREFIX}'
        else:
            env.SUBUNIT_FORMATTER = '${PYTHON} -u ${srcdir}/selftest/format-subunit --prefix=${SELFTEST_PREFIX} --immediate'
    env.FILTER_XFAIL = ('${PYTHON} -u ${srcdir}/selftest/filter-subunit '
                        '--expected-failures=${srcdir}/selftest/knownfail '
                        '--expected-failures=${srcdir}/selftest/knownfail.d '
                        '--flapping=${srcdir}/selftest/flapping '
                        '--flapping=${srcdir}/selftest/flapping.d')

    if Options.options.FAIL_IMMEDIATELY:
        env.FILTER_XFAIL += ' --fail-immediately'

    env.FORMAT_TEST_OUTPUT = '${SUBUNIT_FORMATTER}'

    # clean any previous temporary files
    os.system("rm -rf %s/tmp" % env.SELFTEST_PREFIX);

    # put all command line options in the environment as TESTENV_*=*
    for o in dir(Options.options):
        if o[0:1] != '_':
            val = getattr(Options.options, o, '')
            if not issubclass(type(val), types.FunctionType) \
                    and not issubclass(type(val), types.MethodType):
                os.environ['TESTENV_%s' % o.upper()] = str(getattr(Options.options, o, ''))

    env.OPTIONS = ''
    if not Options.options.SLOWTEST:
        env.OPTIONS += ' --exclude=${srcdir}/selftest/slow'
    if Options.options.QUICKTEST:
        env.OPTIONS += ' --quick --include=${srcdir}/selftest/quick'
    if Options.options.LOAD_LIST:
        env.OPTIONS += ' --load-list=%s' % Options.options.LOAD_LIST
    if Options.options.TESTENV:
        env.OPTIONS += ' --testenv'
    if Options.options.SOCKET_WRAPPER_PCAP:
        env.OPTIONS += ' --socket-wrapper-pcap'
    if Options.options.SOCKET_WRAPPER_KEEP_PCAP:
        env.OPTIONS += ' --socket-wrapper-keep-pcap'
    if Options.options.RANDOM_ORDER:
        env.OPTIONS += ' --random-order'
    if Options.options.PERF_TEST:
        env.FILTER_OPTIONS = ('${PYTHON} -u ${srcdir}/selftest/filter-subunit '
                              '--perf-test-output')
    else:
        env.FILTER_OPTIONS = '${FILTER_XFAIL}'

    if Options.options.VALGRIND:
        os.environ['VALGRIND'] = 'valgrind -q --num-callers=30'
        if Options.options.VALGRINDLOG is not None:
            os.environ['VALGRIND'] += ' --log-file=%s' % Options.options.VALGRINDLOG

    server_wrapper=''

    if Options.options.VALGRIND_SERVER:
        server_wrapper = '${srcdir}/selftest/valgrind_run _DUMMY=X'
    elif Options.options.GDBTEST:
        server_wrapper = '${srcdir}/selftest/gdb_run _DUMMY=X'

    if Options.options.SCREEN:
        server_wrapper = '${srcdir}/selftest/in_screen %s' % server_wrapper
        os.environ['TERMINAL'] = EXPAND_VARIABLES(opt, '${srcdir}/selftest/in_screen')
    elif server_wrapper != '':
        server_wrapper = 'xterm -n server -l -e %s' % server_wrapper

    if server_wrapper != '':
        os.environ['SAMBA_VALGRIND'] = EXPAND_VARIABLES(opt, server_wrapper)
        os.environ['NMBD_VALGRIND'] = EXPAND_VARIABLES(opt, server_wrapper)
        os.environ['WINBINDD_VALGRIND'] = EXPAND_VARIABLES(opt, server_wrapper)
        os.environ['SMBD_VALGRIND'] = EXPAND_VARIABLES(opt, server_wrapper)

    # this is needed for systems without rpath, or with rpath disabled
    ADD_LD_LIBRARY_PATH('bin/shared')
    ADD_LD_LIBRARY_PATH('bin/shared/private')

    # if we are using a system version of ldb then we need to tell it to
    # load modules from our modules path
    if env.USING_SYSTEM_LDB:
        os.environ['LDB_MODULES_PATH'] = os.path.abspath(
                os.path.join(*(env.cwd + ['bin/modules/ldb'])))

    # tell build system where to find config.h
    os.environ['CONFIG_H'] = 'bin/default/include/config.h'

    # tell the test system where perl is
    if isinstance(env.PERL, list):
        perl = ' '.join(env.PERL)
    else:
        perl = env.PERL
    os.environ['PERL'] = perl

    st_done = os.path.join(env.SELFTEST_PREFIX, 'st_done')
    if os.path.exists(st_done):
        os.unlink(st_done)

    if not os.path.isdir(env.SELFTEST_PREFIX):
        os.makedirs(env.SELFTEST_PREFIX, int('755', 8))

    if Options.options.TEST_LIST:
        env.TESTLISTS = '--testlist=%r' % Options.options.TEST_LIST
    elif Options.options.PERF_TEST:
        env.TESTLISTS = '--testlist="${PYTHON} ${srcdir}/selftest/perf_tests.py|" '
    else:
        env.TESTLISTS = ('--testlist="${PYTHON} ${srcdir}/selftest/tests.py|" ' +
                         '--testlist="${PYTHON} ${srcdir}/source3/selftest/tests.py|" ' +
                         '--testlist="${PYTHON} ${srcdir}/source4/selftest/tests.py|"')

    if CONFIG_SET(opt, 'AD_DC_BUILD_IS_ENABLED'):
        env.SELFTEST_TARGET = "samba"
    else:
        env.SELFTEST_TARGET = "samba3"

    env.OPTIONS += " --nss_wrapper_so_path=" + CONFIG_GET(opt, 'LIBNSS_WRAPPER_SO_PATH')
    env.OPTIONS += " --resolv_wrapper_so_path=" + CONFIG_GET(opt, 'LIBRESOLV_WRAPPER_SO_PATH')
    env.OPTIONS += " --uid_wrapper_so_path=" + CONFIG_GET(opt, 'LIBUID_WRAPPER_SO_PATH')

    # selftest can optionally use kernel namespaces instead of socket-wrapper
    if os.environ.get('USE_NAMESPACES') is None:
        env.OPTIONS += " --socket_wrapper_so_path=" + CONFIG_GET(opt, 'LIBSOCKET_WRAPPER_SO_PATH')

    if not CONFIG_SET(opt, 'HAVE_RESOLV_CONF_SUPPORT'):
        env.OPTIONS += " --use-dns-faking"

    if CONFIG_GET(opt, 'USING_SYSTEM_KRB5') and CONFIG_GET(opt, 'MIT_KDC_PATH'):
        env.OPTIONS += " --mitkrb5 --exclude=${srcdir}/selftest/skip_mit_kdc"
        env.FILTER_XFAIL += " --expected-failures=${srcdir}/selftest/"\
                            "knownfail_mit_kdc"
    else:
        env.FILTER_XFAIL += " --expected-failures=${srcdir}/selftest/"\
                            "knownfail_heimdal_kdc"

    if not CONFIG_GET(opt, 'HAVE_GSS_KRB5_CRED_NO_CI_FLAGS_X'):

=== source3/wscript ===
#!/usr/bin/env python

srcdir = ".."

import sys, os
from optparse import SUPPRESS_HELP
sys.path.insert(0, srcdir + "/buildtools/wafsamba")
sys.path.insert(0, "source3")

from waflib import Options, Logs, Errors
import wafsamba
import build.charset
from wafsamba import samba_utils
from samba_utils import TO_LIST
import samba3

default_prefix = Options.default_prefix = '/usr/local/samba'

def options(opt):

    opt.add_option('--with-static-modules',
                   help=("Comma-separated list of names of modules to statically link in. "+
                         "May include !module to disable 'module'. "+
                         "Can be '!FORCED' to disable all non-required static only modules. "+
                         "Can be '!DEFAULT' to disable all modules defaulting to a static build. "+
                         "Can be 'ALL' to build all default shared modules static. "+
                         "The most specific one wins, while the order is ignored "+
                         "and --with-static-modules is evaluated before "+
                         "--with-shared-modules"),
                   action="store", dest='static_modules', default=None)
    opt.add_option('--with-shared-modules',
                   help=("Comma-separated list of names of modules to build shared. "+
                         "May include !module to disable 'module'. "+
                         "Can be '!FORCED' to disable all non-required shared only modules. "+
                         "Can be '!DEFAULT' to disable all modules defaulting to a shared build. "+
                         "Can be 'ALL' to build all default static modules shared. "+
                         "The most specific one wins, while the order is ignored "+
                         "and --with-static-modules is evaluated before "+
                         "--with-shared-modules"),
                   action="store", dest='shared_modules', default=None)

# Optional Libraries
# ------------------
#
# Most of the calls to opt.samba_add_onoff_option() implicitly
# or explicity use default=True
#
# To assist users and distributors to build Samba with the full feature
# set, the build system will abort if our dependent libraries and their
# header files are not found on the target system.  This will mean for
# example, that xattr, acl and ldap headers must be installed for the
# default build to complete.  The configure system will check for these
# headers, and the error message will indicate the option (such as
# --without-acl-support) that can be specified to skip this requirement.
#
# This will assist users and in particular distributors in building fully
# functional packages, while allowing those on systems truly without these
# facilities to continue to build Samba after careful consideration.
#
# It also ensures our container image generation in bootstrap/ is correct
# as otherwise a missing package there would just silently work

    opt.samba_add_onoff_option('winbind')
    opt.samba_add_onoff_option('ads')
    opt.samba_add_onoff_option('ldap')
    opt.samba_add_onoff_option('cups', with_name="enable", without_name="disable")
    opt.samba_add_onoff_option('iprint', with_name="enable", without_name="disable")
    opt.samba_add_onoff_option('pam')
    opt.samba_add_onoff_option('quotas', default=None)
    opt.samba_add_onoff_option('sendfile-support', default=None)
    opt.samba_add_onoff_option('utmp')
    opt.samba_add_onoff_option('avahi', with_name="enable", without_name="disable")
    opt.samba_add_onoff_option('iconv')
    opt.samba_add_onoff_option('acl-support')
    opt.samba_add_onoff_option('syslog')
    opt.samba_add_onoff_option('automount')
    opt.samba_add_onoff_option('dmapi', default=None) # None means autodetection
    opt.samba_add_onoff_option('fam', default=None) # None means autodetection
    opt.samba_add_onoff_option('profiling-data', default=False)
    opt.samba_add_onoff_option('libarchive', default=True)

    opt.samba_add_onoff_option('cluster-support', default=False)

    opt.samba_add_onoff_option('regedit', default=None)
    opt.samba_add_onoff_option('winexe', default=None)

    opt.samba_add_onoff_option('fake-kaserver',
                          help=("Include AFS fake-kaserver support"), default=False)

    opt.add_option('--with-libcephfs',
                   help=("Directory under which libcephfs is installed"),
                   action="store", dest='libcephfs_dir', default=None)

    opt.samba_add_onoff_option('glusterfs', with_name="enable", without_name="disable", default=True)
    opt.samba_add_onoff_option('cephfs', with_name="enable", without_name="disable", default=True)

    opt.add_option('--enable-vxfs',
                  help=("enable support for VxFS (default=no)"),
                  action="store_true", dest='enable_vxfs', default=False)

    # default = None means autodetection
    opt.samba_add_onoff_option('spotlight', with_name="enable", without_name="disable", default=None)

def configure(conf):
    default_static_modules = []
    default_shared_modules = []
    required_static_modules = []
    forced_static_modules = []
    forced_shared_modules = []

    if Options.options.developer:
        conf.ADD_CFLAGS('-DDEVELOPER -DDEBUG_PASSWORD')
        conf.env.developer = True

    if sys.platform != 'openbsd5':
        conf.ADD_LDFLAGS("-Wl,--export-dynamic", testflags=True)

    # We crash without vfs_default
    # and vfs_not_implemented provides helper function
    # for other modules
    required_static_modules.extend(['vfs_default', 'vfs_not_implemented'])

    conf.CHECK_HEADERS('netdb.h')
    conf.CHECK_HEADERS('linux/falloc.h linux/ioctl.h')

    conf.CHECK_FUNCS('getcwd fchown chmod fchmod mknod mknodat')
    conf.CHECK_FUNCS('strtol strchr strupr chflags fchflags')
    conf.CHECK_FUNCS('getrlimit fsync setpgid')
    conf.CHECK_FUNCS('setsid glob strpbrk crypt16 getauthuid')
    conf.CHECK_FUNCS('innetgr')
    conf.CHECK_FUNCS('initgroups select poll rdchk getgrnam getgrent pathconf')
    conf.CHECK_FUNCS('setpriv setgidx setuidx setgroups syscall sysconf')
    conf.CHECK_FUNCS('atexit grantpt posix_openpt fallocate')
    conf.CHECK_FUNCS('fseeko setluid')
    conf.CHECK_FUNCS('getpwnam', headers='sys/types.h pwd.h')
    conf.CHECK_FUNCS('fdopendir')
    conf.CHECK_FUNCS('getpwent_r setenv clearenv strcasecmp')
    conf.CHECK_FUNCS('syslog vsyslog timegm setlocale')
    conf.CHECK_FUNCS('lutimes utimensat futimens')
    conf.CHECK_FUNCS('mlock munlock mlockall munlockall')
    conf.CHECK_FUNCS('memalign posix_memalign hstrerror')
    conf.CHECK_FUNCS('getdomainname')
    conf.CHECK_FUNCS_IN('dn_expand _dn_expand __dn_expand', 'resolv')
    conf.CHECK_FUNCS_IN('dn_expand', 'inet')
    conf.CHECK_DECLS('readahead', reverse=True, headers='fcntl.h')

    if conf.CHECK_CODE('''
#if defined(HAVE_UNISTD_H)
#include <unistd.h>
#endif
long ret = splice(0,0,1,0,400,SPLICE_F_MOVE);
''',
        'HAVE_LINUX_SPLICE',
        headers='fcntl.h'):
        conf.CHECK_DECLS('splice', reverse=True, headers='fcntl.h')

    # Check for inotify support (Skip if we are SunOS)
    #NOTE: illumos provides sys/inotify.h but is not an exact match for linux
    host_os = sys.platform
    if host_os.rfind('sunos') == -1:
        conf.CHECK_HEADERS('sys/inotify.h')
        if conf.env.HAVE_SYS_INOTIFY_H:
           conf.DEFINE('HAVE_INOTIFY', 1)

    # Check for Linux kernel oplocks
    if conf.CHECK_DECLS('F_SETLEASE', headers='linux/fcntl.h', reverse=True):
        conf.DEFINE('HAVE_KERNEL_OPLOCKS_LINUX', 1)

    # Check for kernel share modes
    conf.CHECK_CODE('''
#include <sys/types.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/file.h>
#ifndef LOCK_MAND
#define LOCK_MAND        32
#define LOCK_READ        64
#endif
main() {
        exit(flock(open("/dev/null", O_RDWR), LOCK_MAND|LOCK_READ) != 0);
}''', 'HAVE_KERNEL_SHARE_MODES', addmain=False, execute=True,
        msg="Checking for kernel share modes")

    # check for fam libs
    samba_fam_libs=None
    check_for_fam=False
    if Options.options.with_fam is None:
        check_for_fam=True
    elif Options.options.with_fam == True:
        check_for_fam=True

    if check_for_fam and conf.CHECK_HEADERS('fam.h'):
        if conf.CHECK_FUNCS_IN('FAMOpen2', 'fam'):
            samba_fam_libs='fam'
        elif conf.CHECK_FUNCS_IN('FAMOpen2', 'fam C'):
            samba_fam_libs='fam C'
        conf.CHECK_TYPE('enum FAMCodes', headers='fam.h',
            define='HAVE_FAM_H_FAMCODES_TYPEDEF',
            msg='Checking whether enum FAMCodes is available')
        conf.CHECK_FUNCS_IN('FAMNoExists', 'fam')

    if samba_fam_libs is not None:
        conf.DEFINE('SAMBA_FAM_LIBS', samba_fam_libs)
        conf.DEFINE('HAVE_FAM', 1)
    else:
        if Options.options.with_fam == True:
            conf.fatal('FAM support requested, but no suitable FAM library found')
        elif check_for_fam:
            Logs.warn('no suitable FAM library found')

    # check for libarchive (tar command in smbclient)
    # None means autodetect, True/False means enable/disable
    conf.SET_TARGET_TYPE('archive', 'EMPTY')
    if Options.options.with_libarchive is not False:
        Logs.info("Checking for libarchive existence")
        if conf.CHECK_HEADERS('archive.h') and conf.CHECK_LIB('archive', shlib=True):
            conf.CHECK_FUNCS_IN('archive_read_support_filter_all archive_read_free', 'archive')
        else:
            conf.fatal("libarchive support not found. "
                       "Try installing libarchive-dev or libarchive-devel. "
                       "Otherwise, use --without-libarchive to "
                       "build without libarchive support. "
                       "libarchive support is required for the smbclient "
                       "tar-file mode")
    elif conf.CONFIG_GET('ENABLE_SELFTEST'):
        raise Errors.WafError('libarchive library required for '
                             '--enable-selftest')


    # check for DMAPI libs
    if Options.options.with_dmapi == False:
        have_dmapi = False
    else:
        have_dmapi = True
        Logs.info("Checking for DMAPI library existence")
        samba_dmapi_lib = ''
        if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'dm'):
            samba_dmapi_lib = 'dm'
        else:
            if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'jfsdm'):
                samba_dmapi_lib = 'jfsdm'
            else:
                if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'dmapi'):
                    samba_dmapi_lib = 'dmapi'
                else:
                    if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'xdsm'):
                        samba_dmapi_lib = 'xdsm'
        # only bother to test headers and compilation when a candidate
        # library has been found
        if samba_dmapi_lib == '':
            have_dmapi = False
            broken_dmapi = "no suitable DMAPI library found"

        if have_dmapi:
            conf.CHECK_HEADERS('sys/dmi.h xfs/dmapi.h sys/jfsdmapi.h sys/dmapi.h dmapi.h')
            conf.CHECK_CODE('''
#include <time.h>      /* needed by Tru64 */
#include <sys/types.h> /* needed by AIX */
#ifdef HAVE_XFS_DMAPI_H
#include <xfs/dmapi.h>
#elif defined(HAVE_SYS_DMI_H)
#include <sys/dmi.h>
#elif defined(HAVE_SYS_JFSDMAPI_H)
#include <sys/jfsdmapi.h>
#elif defined(HAVE_SYS_DMAPI_H)
#include <sys/dmapi.h>
#elif defined(HAVE_DMAPI_H)
#include <dmapi.h>
#endif

/* This link test is designed to fail on IRI 6.4, but should
 * succeed on Linux, IRIX 6.5 and AIX.
 */
int main(int argc, char **argv)
{
	char * version;
	dm_eventset_t events;
	/* This doesn't take an argument on IRIX 6.4. */
	dm_init_service(&version);
	/* IRIX 6.4 expects events to be a pointer. */
	DMEV_ISSET(DM_EVENT_READ, events);

	return 0;
}
''',
            'USEABLE_DMAPI_LIBRARY',
            addmain=False,
            execute=False,
            lib=samba_dmapi_lib,
            msg='Checking whether DMAPI lib '+samba_dmapi_lib+' can be used')

=== third_party/wscript ===
#!/usr/bin/env python

from waflib import Options

def configure(conf):
    conf.RECURSE('cmocka')
    conf.RECURSE('popt')
    conf.RECURSE('aesni-intel')
    if conf.CONFIG_GET('ENABLE_SELFTEST'):
        conf.RECURSE('socket_wrapper')
        conf.RECURSE('nss_wrapper')
        conf.RECURSE('resolv_wrapper')
        conf.RECURSE('uid_wrapper')
        if Options.options.with_pam:
            conf.RECURSE('pam_wrapper')


def build(bld):
    bld.RECURSE('cmocka')
    bld.RECURSE('popt')
    bld.RECURSE('aesni-intel')
    if bld.CONFIG_GET('SOCKET_WRAPPER'):
        bld.RECURSE('socket_wrapper')
    if bld.CONFIG_GET('NSS_WRAPPER'):
        bld.RECURSE('nss_wrapper')
    if bld.CONFIG_GET('RESOLV_WRAPPER'):
        bld.RECURSE('resolv_wrapper')
    if bld.CONFIG_GET('UID_WRAPPER'):
        bld.RECURSE('uid_wrapper')
    if bld.CONFIG_GET('PAM_WRAPPER'):
        bld.RECURSE('pam_wrapper')

=== lib/replace/wscript ===
#!/usr/bin/env python

APPNAME = 'libreplace'
VERSION = '1.2.1'

import sys
import os

# find the buildtools directory
top = '.'
while not os.path.exists(top+'/buildtools') and len(top.split('/')) < 5:
    top = top + '/..'
sys.path.insert(0, top + '/buildtools/wafsamba')

out = 'bin'

import wafsamba
from wafsamba import samba_dist
from waflib import Options, Utils, Logs, Context

samba_dist.DIST_DIRS('lib/replace buildtools:buildtools third_party/waf:third_party/waf')

def options(opt):
    opt.BUILTIN_DEFAULT('NONE')
    opt.PRIVATE_EXTENSION_DEFAULT('')
    opt.RECURSE('buildtools/wafsamba')

@Utils.run_once
def configure(conf):
    conf.RECURSE('buildtools/wafsamba')

    conf.env.standalone_replace = conf.IN_LAUNCH_DIR()

    if sys.platform.rfind('linux') > -1:
        conf.DEFINE('LINUX', '1')

    conf.DEFINE('BOOL_DEFINED', 1)
    conf.DEFINE('HAVE_LIBREPLACE', 1)
    conf.DEFINE('LIBREPLACE_NETWORK_CHECKS', 1)

    conf.CHECK_HEADERS('linux/types.h crypt.h locale.h acl/libacl.h compat.h')
    conf.CHECK_HEADERS('acl/libacl.h attr/xattr.h compat.h ctype.h dustat.h')
    conf.CHECK_HEADERS('fcntl.h fnmatch.h glob.h history.h krb5.h langinfo.h')
    conf.CHECK_HEADERS('locale.h ndir.h pwd.h')
    conf.CHECK_HEADERS('shadow.h sys/acl.h')
    conf.CHECK_HEADERS('sys/attributes.h attr/attributes.h sys/capability.h sys/dir.h sys/epoll.h')
    conf.CHECK_HEADERS('port.h')
    conf.CHECK_HEADERS('sys/fcntl.h sys/filio.h sys/filsys.h sys/fs/s5param.h')
    conf.CHECK_HEADERS('sys/id.h sys/ioctl.h sys/ipc.h sys/mman.h sys/mode.h sys/ndir.h sys/priv.h')
    conf.CHECK_HEADERS('sys/resource.h sys/security.h sys/shm.h sys/statfs.h sys/statvfs.h sys/termio.h')
    conf.CHECK_HEADERS('sys/vfs.h sys/xattr.h termio.h termios.h sys/file.h')
    conf.CHECK_HEADERS('sys/ucontext.h sys/wait.h sys/stat.h')

    if not conf.CHECK_DECLS('malloc', headers='stdlib.h'):
        conf.CHECK_HEADERS('malloc.h')

    conf.CHECK_HEADERS('grp.h')
    conf.CHECK_HEADERS('sys/select.h setjmp.h utime.h sys/syslog.h syslog.h')
    conf.CHECK_HEADERS('stdarg.h vararg.h sys/mount.h mntent.h')
    conf.CHECK_HEADERS('stropts.h unix.h string.h strings.h sys/param.h limits.h')
    conf.CHECK_HEADERS('''sys/socket.h netinet/in.h netdb.h arpa/inet.h netinet/in_systm.h
                          netinet/ip.h netinet/tcp.h netinet/in_ip.h
                          sys/sockio.h sys/un.h''', together=True)
    conf.CHECK_HEADERS('sys/uio.h ifaddrs.h direct.h dirent.h')
    conf.CHECK_HEADERS('windows.h winsock2.h ws2tcpip.h')
    conf.CHECK_HEADERS('errno.h')
    conf.CHECK_HEADERS('getopt.h iconv.h')
    conf.CHECK_HEADERS('memory.h nss.h sasl/sasl.h')

    conf.CHECK_FUNCS_IN('inotify_init', 'inotify', checklibc=True,
                        headers='sys/inotify.h')

    conf.CHECK_HEADERS('security/pam_appl.h zlib.h asm/unistd.h')
    conf.CHECK_HEADERS('sys/unistd.h alloca.h float.h')

    conf.SET_TARGET_TYPE('tirpc', 'EMPTY')

    if conf.CHECK_CODE(
            '\n#ifndef _TIRPC_RPC_H\n#error "no tirpc headers in system path"\n#endif\n',
            'HAVE_RPC_RPC_HEADERS',
            headers=['rpc/rpc.h', 'rpc/nettype.h'],
            msg='Checking for tirpc rpc headers in default system path'):
        if conf.CONFIG_SET('HAVE_RPC_RPC_H'):
            conf.undefine('HAVE_RPC_RPC_H')

    if not conf.CONFIG_SET('HAVE_RPC_RPC_H'):
        if conf.CHECK_CFG(package='libtirpc', args='--cflags --libs',
                       msg='Checking for libtirpc headers',
                       uselib_store='TIRPC'):
            conf.CHECK_HEADERS('rpc/rpc.h rpc/nettype.h', lib='tirpc', together=True)
            conf.SET_TARGET_TYPE('tirpc', 'SYSLIB')
    if not conf.CONFIG_SET('HAVE_RPC_RPC_H'):
        if conf.CHECK_CFG(package='libntirpc', args='--cflags',
                       msg='Checking for libntirpc headers',
                       uselib_store='TIRPC'):
            conf.CHECK_HEADERS('rpc/rpc.h rpc/nettype.h', lib='tirpc', together=True)
            conf.SET_TARGET_TYPE('tirpc', 'SYSLIB')
    if not conf.CONFIG_SET('HAVE_RPC_RPC_H'):
            Logs.warn('No rpc/rpc.h header found, tirpc or libntirpc missing?')

    # This file is decprecated with glibc >= 2.30 so we need to check if it
    # includes a deprecation warning:
    # #warning "The <sys/sysctl.h> header is deprecated and will be removed."
    conf.CHECK_CODE('''
                    #include <sys/sysctl.h>
                    int main(void) { return 0; }
                    ''',
                    define='HAVE_SYS_SYSCTL_H',
                    cflags=['-Werror=cpp'],
                    addmain=False,
                    msg='Checking for header sys/sysctl.h')

    conf.CHECK_HEADERS('sys/fileio.h sys/filesys.h sys/dustat.h sys/sysmacros.h')
    conf.CHECK_HEADERS('xfs/libxfs.h netgroup.h')

    conf.CHECK_HEADERS('valgrind.h valgrind/valgrind.h')
    conf.CHECK_HEADERS('valgrind/memcheck.h valgrind/helgrind.h')
    conf.CHECK_HEADERS('nss_common.h nsswitch.h ns_api.h')
    conf.CHECK_HEADERS('sys/extattr.h sys/ea.h sys/proplist.h sys/cdefs.h')
    conf.CHECK_HEADERS('utmp.h utmpx.h lastlog.h')
    conf.CHECK_HEADERS('syscall.h sys/syscall.h inttypes.h')
    conf.CHECK_HEADERS('sys/atomic.h stdatomic.h')
    conf.CHECK_HEADERS('libgen.h')

    if conf.CHECK_CFLAGS('-Wno-format-truncation'):
        conf.define('HAVE_WNO_FORMAT_TRUNCATION', '1')

    if conf.CHECK_CFLAGS('-Wno-unused-function'):
        conf.define('HAVE_WNO_UNUSED_FUNCTION', '1')

    if conf.CHECK_CFLAGS('-Wno-strict-overflow'):
        conf.define('HAVE_WNO_STRICT_OVERFLOW', '1')

    # Check for process set name support
    conf.CHECK_CODE('''
                    #include <sys/prctl.h>
                    int main(void) {
                        prctl(0);
                        return 0;
                    }
                    ''',
                    'HAVE_PRCTL',
                    addmain=False,
                    headers='sys/prctl.h',
                    msg='Checking for prctl syscall')

    conf.CHECK_CODE('''
                    #include <unistd.h>
                    #ifdef HAVE_FCNTL_H
                    #include <fcntl.h>
                    #endif
                    int main(void) { int fd = open("/dev/null", O_DIRECT); }
                    ''',
                    define='HAVE_OPEN_O_DIRECT',
                    addmain=False,
                    msg='Checking for O_DIRECT flag to open(2)')

    conf.CHECK_TYPES('"long long" intptr_t uintptr_t ptrdiff_t comparison_fn_t')
    conf.CHECK_TYPE('_Bool', define='HAVE__Bool')
    conf.CHECK_TYPE('bool', define='HAVE_BOOL')

    conf.CHECK_TYPE('int8_t', 'char')
    conf.CHECK_TYPE('uint8_t', 'unsigned char')
    conf.CHECK_TYPE('int16_t', 'short')
    conf.CHECK_TYPE('uint16_t', 'unsigned short')
    conf.CHECK_TYPE('int32_t', 'int')
    conf.CHECK_TYPE('uint32_t', 'unsigned')
    conf.CHECK_TYPE('int64_t', 'long long')
    conf.CHECK_TYPE('uint64_t', 'unsigned long long')
    conf.CHECK_TYPE('size_t', 'unsigned int')
    conf.CHECK_TYPE('ssize_t', 'int')
    conf.CHECK_TYPE('ino_t', 'unsigned')
    conf.CHECK_TYPE('loff_t', 'off_t')
    conf.CHECK_TYPE('offset_t', 'loff_t')
    conf.CHECK_TYPE('volatile int', define='HAVE_VOLATILE')
    conf.CHECK_TYPE('uint_t', 'unsigned int')
    conf.CHECK_TYPE('blksize_t', 'long', headers='sys/types.h sys/stat.h unistd.h')
    conf.CHECK_TYPE('blkcnt_t', 'long', headers='sys/types.h sys/stat.h unistd.h')

    conf.CHECK_SIZEOF('bool char int "long long" long short size_t ssize_t')
    conf.CHECK_SIZEOF('int8_t uint8_t int16_t uint16_t int32_t uint32_t int64_t uint64_t')
    conf.CHECK_SIZEOF('void*', define='SIZEOF_VOID_P')
    conf.CHECK_SIZEOF('off_t dev_t ino_t time_t')

    conf.CHECK_TYPES('socklen_t', headers='sys/socket.h')
    conf.CHECK_TYPE_IN('struct ifaddrs', 'ifaddrs.h')
    conf.CHECK_TYPE_IN('struct addrinfo', 'netdb.h')
    conf.CHECK_TYPE_IN('struct sockaddr', 'sys/socket.h')
    conf.CHECK_CODE('struct sockaddr_in6 x', define='HAVE_STRUCT_SOCKADDR_IN6',
                    headers='sys/socket.h netdb.h netinet/in.h')
    conf.CHECK_TYPE_IN('struct sockaddr_storage', 'sys/socket.h')
    conf.CHECK_TYPE_IN('sa_family_t', 'sys/socket.h')

    conf.CHECK_TYPE_IN('sig_atomic_t', 'signal.h', define='HAVE_SIG_ATOMIC_T_TYPE')
    conf.CHECK_FUNCS('sigsetmask siggetmask sigprocmask sigblock sigaction sigset')

    # Those functions are normally available in libc
    if not conf.CHECK_FUNCS('''
                            inet_ntoa
                            inet_aton
                            inet_ntop
                            inet_pton
                            connect
                            gethostbyname
                            getaddrinfo
                            getnameinfo
                            freeaddrinfo
                            gai_strerror
                            socketpair''',
                            headers='sys/socket.h netinet/in.h arpa/inet.h netdb.h'):
        conf.CHECK_FUNCS_IN('''
                            inet_ntoa
                            inet_aton
                            inet_ntop
                            inet_pton
                            connect
                            gethostbyname
                            getaddrinfo
                            getnameinfo
                            freeaddrinfo
                            gai_strerror
                            socketpair''',
                            'socket nsl',
                            headers='sys/socket.h netinet/in.h arpa/inet.h netdb.h')
        conf.DEFINE('REPLACE_REQUIRES_LIBSOCKET_LIBNSL', 1)

    conf.CHECK_FUNCS('memset_s memset_explicit')

    conf.CHECK_CODE('''
                    #include <string.h>

                    int main(void)
                    {
                        char buf[] = "This is some content";
                        memset(buf, '\0', sizeof(buf)); __asm__ volatile("" : : "g"(&buf) : "memory");
                        return 0;
                    }
                    ''',
                    define='HAVE_GCC_VOLATILE_MEMORY_PROTECTION',
                    addmain=False,
                    msg='Checking for volatile memory protection',
                    local_include=False)

    # Some old Linux systems have broken header files and
    # miss the IPV6_V6ONLY define in netinet/in.h,
    # but have it in linux/in6.h.
    # We can't include both files so we just check if the value
    # if defined and do the replacement in system/network.h
    if not conf.CHECK_VARIABLE('IPV6_V6ONLY',
                               headers='sys/socket.h netdb.h netinet/in.h'):
        conf.CHECK_CODE('''
                        #include <linux/in6.h>
                        #if (IPV6_V6ONLY != 26)
                        #error no IPV6_V6ONLY support on linux
                        #endif
                        int main(void) { return IPV6_V6ONLY; }
                        ''',
                        define='HAVE_LINUX_IPV6_V6ONLY_26',
                        addmain=False,
                        msg='Checking for IPV6_V6ONLY in linux/in6.h',
                        local_include=False)

    conf.CHECK_CODE('''
                       struct sockaddr_storage sa_store;
                       struct addrinfo *ai = NULL;
                       struct in6_addr in6addr;
                       int idx = if_nametoindex("iface1");
                       int s = socket(AF_INET6, SOCK_STREAM, 0);
                       int ret = getaddrinfo(NULL, NULL, NULL, &ai);
                       if (ret != 0) {
                           const char *es = gai_strerror(ret);
                       }
                       freeaddrinfo(ai);
                       {
                          int val = 1;
                          #ifdef HAVE_LINUX_IPV6_V6ONLY_26
                          #define IPV6_V6ONLY 26
                          #endif

=== debian/changelog ===
samba (2:4.15.13+dfsg-0ubuntu0.20.04.8) focal; urgency=medium

  * d/p/lp2046994-spotlight-doesnt-work-with-latest-macos-ventura.patch: fix
    spotlight search function on macos ventura (LP: #2046994).

 -- Mitchell Dzurick <mitchell.dzurick@canonical.com>  Thu, 01 Feb 2024 11:24:27 -0700

samba (2:4.15.13+dfsg-0ubuntu0.20.04.7) focal-security; urgency=medium

  * No-change rebuild to fix build issue resulting in regressions.
    (LP: #2039031)

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 11 Oct 2023 13:30:13 -0400

samba (2:4.15.13+dfsg-0ubuntu0.20.04.6) focal-security; urgency=medium

  * SECURITY UPDATE: SMB clients can truncate files with read-only
    permissions
    - debian/patches/CVE-2023-4091-*.patch
    - CVE-2023-4091
  * SECURITY UPDATE: Samba AD DC password exposure to privileged users and
    RODCs
    - debian/patches/CVE-2023-4154-*.patch
    - CVE-2023-4154
  * SECURITY UPDATE: rpcecho development server allows Denial of Service
    via sleep() call on AD DC
    - debian/patches/CVE-2023-42669.patch
    - CVE-2023-42669

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 04 Oct 2023 09:02:06 -0400

samba (2:4.15.13+dfsg-0ubuntu0.20.04.5) focal; urgency=medium

  * d/p/issue-when-updating-old-passwd-containing-regex-metachars.patch:
    Add changes to fix uncaught exception when updating old password
    containing regex metacharacters by simplifying samba-tool password
    redaction (LP: #2002949).

 -- Michal Maloszewski <michal.maloszewski@canonical.com>  Fri, 18 Aug 2023 22:56:58 +0200

samba (2:4.15.13+dfsg-0ubuntu0.20.04.4) focal; urgency=medium

  * d/p/secure-channel-faulty-kb5028166.patch: fix domain membership
    after Windows KB5028166 update (LP: #2027716)
  * Cherry pick samba AD DC provisioning DEP8 test from later Ubuntu
    releases (LP: #1977746, LP: #2011745):
    - d/t/control, d/t/util,d/t/samba-ad-dc-provisioning-internal-dns:
      samba AD DC provisioning and domain join tests with internal DNS
      + d/t/control: adjust package dependencies
      + d/t/samba-ad-dc-provisioning-internal-dns: handle the case where
        libnss-winbind does not automatically add winbind to
        /etc/nsswitch.conf (that is done only in Lunar and later)
      + d/t/samba-ad-dc-provisioning-internal-dns: use case insensitive
        match when inspecting kerberos tickets, as the hostname may be
        capitalized
      + d/t/samba-ad-dc-provisioning-internal-dns: Adjust regexp for
        slightly different resolvectl output
      + d/t/util: several lxc command output parsing changes, needed for
        this older version of the lxd snap
      + d/t/samba-ad-dc-provisioning-internal-dns: more dependencies for
        the winbind and sssd domain join tests, which don't get
        installed automatically for us by this version of realmd
      + d/t/util: increase the RLIMIT_MEMLOCK limit for lxd containers,
        as the default of 64kb is too low for at least ppc64el on focal

 -- Andreas Hasenack <andreas@canonical.com>  Sun, 23 Jul 2023 17:19:48 -0300

samba (2:4.15.13+dfsg-0ubuntu0.20.04.3) focal-security; urgency=medium

  * SECURITY UPDATE: Out-Of-Bounds read in winbind AUTH_CRAP
    - debian/patches/CVE-2022-2127-*.patch
    - CVE-2022-2127
  * SECURITY UPDATE: Spotlight mdssvc RPC Request Infinite Loop DoS
    - debian/patches/CVE-2023-34966-*.patch
    - CVE-2023-34966
  * SECURITY UPDATE: Spotlight mdssvc RPC Request Type Confusion DoS
    - debian/patches/CVE-2023-34967-*.patch
    - CVE-2023-34967
  * SECURITY UPDATE: Spotlight server-side Share Path Disclosure
    - debian/patches/CVE-2023-34968-*.patch
    - CVE-2023-34968

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 11 Jul 2023 08:45:47 -0400

samba (2:4.15.13+dfsg-0ubuntu0.20.04.2) focal-security; urgency=medium

  * SECURITY UPDATE: Access controlled AD LDAP attributes can be discovered
    - debian/patches/CVE-2023-0614-*.patch: upstream patches to fix the
      issue (some of these aren't directly used in this package as they
      apply to the ldb library which is updated separately).
    - debian/control: bump ldb Build-Depends to security update version.
    - CVE-2023-0614
  * SECURITY UPDATE: admin tool samba-tool sends passwords in cleartext
    - debian/patches/CVE-2023-0922.patch: set default ldap client sasl
      wrapping to seal.
    - CVE-2023-0922

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 30 Mar 2023 09:25:19 -0400

samba (2:4.15.13+dfsg-0ubuntu0.20.04.1) focal-security; urgency=medium

  * Update to 4.15.13 as a security update
    - Removed patches included in new version:
      + CVE-*.patch
      + win-22H2-fix*.patch
      + Rename-mdfind-to-mdsearch.patch
      + lp-1951490-fix-printing-KB5006743.patch
    - d/rules: remove --with-dnsupdate, it was merged with --with-ads.
    - debian/control: bump libldb-dev Build-Depends to 2.4.4, bump
      libtalloc to 2.3.3, libtdb to 1.4.4, and libtevent to 0.11.0.
    - debian/control: added python3-markdown to Build-Depends.
    - debian/{gpb.conf,watch,README.source}: updated for 4.15.
    - debian/{*.install,*.symbols,*.lintian-overrides}: updated for 4.15.
    - debian/rules: drop fixing of findsmb shebang.
    - debian/rules: drop removal of ctdb tests, they are no longer
      installed.
    - CVE-2022-3437, CVE-2022-37966, CVE-2022-37967, CVE-2022-38023,
      CVE-2022-42898, CVE-2022-45141

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 24 Feb 2023 07:31:43 -0500

samba (2:4.13.17~dfsg-0ubuntu1.20.04.5) focal-security; urgency=medium

  * SECURITY UPDATE: Multiple regressions (LP: #2003867) (LP: #2003891)
    - debian/patches/series: disable all security fixes from the previous
      update pending further investigation. This reverts the following
      CVEs: CVE-2022-3437, CVE-2022-42898, CVE-2022-45141, CVE-2022-38023,
      CVE-2022-37966, CVE-2022-37967.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 26 Jan 2023 09:03:40 -0500



=== debian/control ===
Source: samba
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>,
           Jelmer Vernooĳ <jelmer@debian.org>,
           Mathieu Parent <sathieu@debian.org>,
           Andrew Bartlett <abartlet+debian@catalyst.net.nz>
Homepage: http://www.samba.org
Standards-Version: 4.4.1
Build-Depends: bison,
               debhelper-compat (= 12),
               dh-exec,
               dh-python,
               docbook-xml,
               docbook-xsl,
               flex,
               libacl1-dev,
               libarchive-dev,
               libattr1-dev,
               libavahi-client-dev,
               libavahi-common-dev,
               libblkid-dev,
               libbsd-dev,
               libcap-dev [linux-any],
               libcephfs-dev [amd64 arm64 armel armhf mips64el mipsel ppc64el ppc64 s390x x32],
               libcmocka-dev (>= 1.1.3),
               libcups2-dev,
               libdbus-1-dev,
               libgnutls28-dev,
               libgpgme11-dev,
               libicu-dev,
               libjansson-dev,
               libldap2-dev,
               libldb-dev (>= 2:2.4.4-0ubuntu0.20.04.2~),
               libncurses5-dev,
               libpam0g-dev,
               libparse-yapp-perl,
               libpcap-dev [hurd-i386 kfreebsd-any],
               libpopt-dev,
               librados-dev [amd64 arm64 armel armhf mips64el mipsel ppc64el ppc64 s390x x32],
               libreadline-dev,
               libsystemd-dev [linux-any],
               libtalloc-dev (>= 2.3.3~),
               libtasn1-6-dev (>= 3.8),
               libtasn1-bin,
               libtdb-dev (>= 1.4.4~),
               libtevent-dev (>= 0.11.0~),
               perl,
               pkg-config,
               po-debconf,
               python3-dev,
               python3-dnspython,
               python3-etcd,
               python3-ldb (>= 2:2.4.4-0ubuntu0.20.04.2~),
               python3-ldb-dev (>= 2:2.4.4-0ubuntu0.20.04.2~),
               python3-markdown,
               python3-talloc-dev (>= 2.3.1~),
               python3-tdb (>= 1.4.3~),
               python3-testtools,
               python3,
               xfslibs-dev [linux-any],
               xsltproc,
               zlib1g-dev (>= 1:1.2.3)
Build-Conflicts: libtracker-miner-2.0-dev,
                 libtracker-sparql-2.0-dev
Rules-Requires-Root: binary-targets
Vcs-Browser: https://salsa.debian.org/samba-team/samba
Vcs-Git: https://salsa.debian.org/samba-team/samba.git

Package: samba
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: adduser,
         libpam-modules,
         libpam-runtime (>= 1.0.1-11),
         lsb-base (>= 4.1+Debian),
         procps,
         python3,
         python3-dnspython,
         python3-samba,
         samba-common (= ${source:Version}),
         samba-common-bin (=${binary:Version}),
         tdb-tools,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: attr,
            logrotate,
            python3-markdown,
            samba-dsdb-modules,
            samba-vfs-modules
Suggests: bind9 (>= 1:9.5.1),
          bind9utils,
          ctdb,
          ldb-tools,
          ntp | chrony (>= 3.0-1),
          smbldap-tools,
          ufw,
          winbind
Enhances: bind9, ntp
Description: SMB/CIFS file, print, and login server for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.  Samba can also function
 as an NT4-style domain controller, and can integrate with both NT4 domains
 and Active Directory realms as a member server.
 .
 This package provides the components necessary to use Samba as a stand-alone
 file and print server or as an NT4 or Active Directory domain controller.
 For use in an NT4 domain or Active Directory realm, you will also need the
 winbind package.
 .
 This package is not required for connecting to existing SMB/CIFS servers
 (see smbclient) or for mounting remote filesystems (see cifs-utils).

Package: samba-libs
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libndr-standard0 (<< 2:4.0.9),
        libsamba-credentials0 (<< 2:4.0.9),
        libsamba-hostconfig0 (<< 2:4.0.9),
        libsamba-util0 (<< 2:4.0.9),
Replaces: samba (<< 2:4.3.3+dfsg-1),
          libndr-standard0 (<< 2:4.0.9),
          libsamba-credentials0 (<< 2:4.0.9),
          libsamba-hostconfig0 (<< 2:4.0.9),
          libsamba-util0 (<< 2:4.0.9),
Description: Samba core libraries
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the shared libraries.

Package: samba-common
Architecture: all
Multi-Arch: foreign
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ucf, ${misc:Depends}
Recommends: samba-common-bin
Description: common files used by both the Samba server and client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains common files used by all parts of Samba.

Package: samba-common-bin
Architecture: any
Depends: python3,
         python3-samba,
         samba-common (=${source:Version}),
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: samba-dsdb-modules
Suggests: heimdal-clients,
          python3-markdown,
          python3-dnspython
Description: Samba common files used by both the server and the client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the common files that are used by both the server
 (provided in the samba package) and the client (provided in the samba-clients
 package).

Package: smbclient
Architecture: any
Depends: samba-common (= ${source:Version}),
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: dpkg (>= 1.15.6~)
Provides: samba-client
Suggests: cifs-utils, heimdal-clients
Description: command-line SMB/CIFS clients for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains command-line utilities for accessing Microsoft
 Windows and Samba servers, including smbclient, smbtar, and smbspool.
 Utilities for mounting shares locally are found in the package
 cifs-utils.

Package: samba-testsuite
Architecture: any
Suggests: subunit
Depends: samba-common-bin,
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: test suite from Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains programs for testing the reliability and speed
 of SMB servers, Samba in particular.

Package: registry-tools
Architecture: any
Depends: samba-libs (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: tools for viewing and manipulating the Windows registry
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains tools for viewing and manipulating the binary
 "registry" found on Windows machines, both locally and remote.

Package: samba-dev
Architecture: any
Multi-Arch: same
Depends: libc6-dev,
         libldb-dev (>= 2:2),
         libpopt-dev,
         libtalloc-dev,
         libtdb-dev,
         libtevent-dev,
         libwbclient-dev,
         samba-libs (= ${binary:Version}),
         ${misc:Depends}
Section: devel
Description: tools for extending Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains include files shared by the various Samba-based
 libraries.

Package: python3-samba
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Section: python
Provides: ${python3:Provides}
Depends: python3-crypto,
         python3-ldb,
         python3-tdb,
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: python3-gpg
Description: Python 3 bindings for Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains Python 3 bindings for most Samba libraries.

Package: samba-dsdb-modules
Architecture: any
Multi-Arch: same
Section: libs
Depends: libgpgme11,
         samba-libs (= ${binary:Version}),
         ${ldb:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Enhances: libldb2
Description: Samba Directory Services Database
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains LDB plugins which add support for various Active
 Directory features to the LDB library.

Package: samba-vfs-modules
Architecture: any
Multi-Arch: same
Breaks: samba (<< 2:4.3.2+dfsg-1), samba-libs (<< 2:4.3.2+dfsg-1)
Replaces: samba (<< 2:4.3.2+dfsg-1), samba-libs (<< 2:4.3.2+dfsg-1)
Depends: samba-libs (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: ${vfsceph:Recommends}, ${vfssnapper:Recommends}
Enhances: samba
Description: Samba Virtual FileSystem plugins
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 Virtual FileSystem modules are stacked shared libraries extending the
 functionality of Samba. Some examples are:
  * vfs_acl_xattr: Save NTFS-ACLs in Extended Attributes
  * vfs_audit: record selected Samba VFS operations in the system log
  * vfs_readonly: Make a Samba share read only for a specified time period
  * vfs_recycle: Give the same effect as the Recycle Bin on Windows computers
  * vfs_shadow_copy2: Expose snapshots to Windows clients as shadow copies
  * vfs_worm: Disallow writes for older file
 .
 Note: The runtime dependencies of vfs_ceph and vfs_snapper are moved to
 Recommends.

=== debian/rules ===
#!/usr/bin/make -f
# By Jelmer Vernooij <jelmer@samba.org>
#
DESTDIR = $(CURDIR)/debian/tmp

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH_CPU ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)

# Ubuntu i386 binary compatibility only effort
UBUNTU_I386 = 0
ifeq ($(shell dpkg-vendor --is Ubuntu && echo yes) $(DEB_HOST_ARCH), yes i386)
    UBUNTU_I386 = 1
endif

LDB_VERSION = $(shell pkg-config --modversion ldb)
LDB_EPOCH = $(shell dpkg-query -f '$${Version}' -W libldb-dev | sed 's/:.*//')
LDB_NEXT_VERSION = $(shell python3 -c "x = '$(LDB_VERSION)'.split('.'); x[-1] = str(int(x[-1])+1); print('.'.join(x))")
# samba ships ldb modules, which are specific to the ldb version, so we need a
# strict dependency on the upstream ldb version
# this also mean samba needs a rebuild when the upstream ldb version changes
LDB_DEPENDS = "libldb2 (<< $(LDB_EPOCH):$(LDB_NEXT_VERSION)~), libldb2 (>> $(LDB_EPOCH):$(LDB_VERSION)~)"
export PYSHORT=python3
export PYTHON=$(shell which $(PYSHORT))
export PYTHON_CONFIG="$(PYTHON)-config"
WAF := $(PYTHON) ./buildtools/bin/waf -v
WAF_NO_PARALLEL := $(WAF) -j 1

# wrapper around cups-config, to work around #726726
export PATH:=$(CURDIR)/debian/bin:$(PATH)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
WAF += -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

conf_args = \
		--prefix=/usr \
		--enable-fhs \
		--sysconfdir=/etc \
		--localstatedir=/var \
		--libexecdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--with-privatedir=/var/lib/samba/private \
		--with-smbpasswd-file=/etc/samba/smbpasswd \
		--with-piddir=/run/samba \
		--with-pammodulesdir=/lib/$(DEB_HOST_MULTIARCH)/security \
		--with-pam \
		--with-syslog \
		--with-utmp \
		--with-winbind \
		--with-quota \
		--with-shared-modules=idmap_rid,idmap_ad,idmap_adex,idmap_hash,idmap_ldap,idmap_tdb2,vfs_dfs_samba4,auth_samba4,vfs_nfs4acl_xattr \
		--with-automount \
		--with-ldap \
		--with-ads \
		--with-gpgme \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--with-modulesdir=/usr/lib/$(DEB_HOST_MULTIARCH)/samba \
		--datadir=/usr/share \
		--with-lockdir=/run/samba \
		--with-statedir=/var/lib/samba \
		--with-cachedir=/var/cache/samba \
		--enable-avahi \
		--disable-rpath \
		--disable-rpath-install \
		--bundled-libraries=NONE,pytevent,iniparser,roken,replace,wind,hx509,asn1,heimbase,hcrypto,krb5,gssapi,heimntlm,hdb,kdc,com_err,compile_et,asn1_compile \
		--builtin-libraries=ccan,samba-cluster-support \
		--minimum-library-version="$(shell ./debian/autodeps.py --minimum-library-version)" \
		--with-cluster-support \
		--with-socketpath=/run/ctdb/ctdbd.socket \
		--with-logdir=/var/log/ctdb \
		--enable-etcd-reclock \
		--enable-spotlight


ifeq ($(UBUNTU_I386), 0)
ifneq (,$(filter amd64 arm64 armel armhf i386 mips64el mipsel ppc64el ppc64 s390x x32, $(DEB_HOST_ARCH)))
	conf_args += \
		--enable-ceph-reclock
else
	conf_args += \
		--disable-cephfs
endif
endif

# Ubuntu i386 binary compatibility only effort: Disable ceph support
ifeq ($(UBUNTU_I386), 1)
	conf_args += \
		--disable-cephfs
endif

ifeq ($(DEB_HOST_ARCH_OS), linux)
	conf_args += \
		--with-systemd \
		--systemd-install-services \
		--with-systemddir=/lib/systemd/system
else
	conf_args += \
		--without-systemd
endif

# Ubuntu i386 binary compatibility only effort: Disable some i386 packages
ifeq ($(UBUNTU_I386), 1)
	BUILD_PACKAGES += \
		-Nctdb \
		-Nlibpam-winbind \
		-Nsamba \
		-Nsamba-testsuite
endif

%:
	dh $* --with python3 $(BUILD_PACKAGES)

override_dh_auto_configure:
	$(WAF_NO_PARALLEL) configure $(conf_args)

override_dh_auto_build:
	DESTDIR="$(DESTDIR)" $(WAF)

override_dh_auto_test:
	# Running make test requires configuration with --enable-selftest, which
	# we don't want to do for production systems.

override_dh_auto_install:
	DESTDIR="$(DESTDIR)" $(WAF) install
	# get list of files in build log
	find ${DESTDIR}
	# Included in python-tevent
	rm $(DESTDIR)/usr/lib/python*/*-packages/_tevent.*
	rm $(DESTDIR)/usr/lib/python*/*-packages/tevent.py
	# Already documented in debian/copyright
	-rm $(DESTDIR)/usr/share/samba/setup/ad-schema/licence.txt
	# System ldb loads its modules from a different path
	mkdir -p $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/ldb/modules/ldb
	ln -sf ../../../samba/ldb $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/ldb/modules/ldb/samba
	# pam stuff
	mkdir -p $(DESTDIR)/usr/share/pam-configs
	install -m 0644 debian/winbind.pam-config $(DESTDIR)/usr/share/pam-configs/winbind
	mv $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libnss_* $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/
	# we don't ship the symlinks
	rm $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/libnss_*.so
	#Remove unused vfstest manpage vfstest is no longer installed
	rm $(DESTDIR)/usr/share/man/man1/vfstest.1
	# Debian goodies to set global option in smb.conf and add a share
	install -m 0755 debian/setoption.py $(DESTDIR)/usr/share/samba
	install -m 0755 debian/addshare.py $(DESTDIR)/usr/share/samba
	# Debian goodies
	cp debian/smb.conf* $(DESTDIR)/usr/share/samba/
	install -m755 debian/panic-action $(DESTDIR)/usr/share/samba/panic-action
	install -m755 debian/update-apparmor-samba-profile $(DESTDIR)/usr/share/samba/update-apparmor-samba-profile
	cp debian/gdbcommands $(DESTDIR)/etc/samba/
	mkdir -p $(DESTDIR)/etc/dhcp/dhclient-enter-hooks.d
	install -m755 debian/samba-common.dhcp $(DESTDIR)/etc/dhcp/dhclient-enter-hooks.d/samba
	install -m 0755 debian/mksmbpasswd.awk $(DESTDIR)/usr/sbin/mksmbpasswd
	mkdir -p $(DESTDIR)/etc/ufw/applications.d
	install -m644 debian/samba.ufw.profile $(DESTDIR)/etc/ufw/applications.d/samba
	mkdir -p $(DESTDIR)/usr/share/apport/package-hooks
	install -D -m 644 debian/source_samba.py $(DESTDIR)/usr/share/apport/package-hooks/source_samba.py
	# Install other stuff not installed by "make install"
	# This moves the dckeytab module to the samba package in order to avoid
	# a circular dependency between python3-samba, samba and samba-common-bin
	mkdir -p debian/samba/usr/lib/$(PYSHORT)/dist-packages/samba
	mv $(DESTDIR)/usr/lib/$(PYSHORT)/dist-packages/samba/dckeytab*.so \
	   debian/samba/usr/lib/$(PYSHORT)/dist-packages/samba/
	# use upstream version of smb.conf.5 if there is no built version
	# this is a temporary workaround for #750593 in xsltproc
	[ -e $(DESTDIR)/usr/share/man/man5/smb.conf.5 ] || \
	   cp docs/manpages/smb.conf.5 $(DESTDIR)/usr/share/man/man5/smb.conf.5
	# Tests that shouldn't be installed
	rm -f $(DESTDIR)/usr/bin/async_connect_send_test
ifeq ($(DEB_HOST_ARCH_OS), linux)
	# Install systemd configs
	mkdir -p $(DESTDIR)/lib/systemd/system/
	install -m 0644 ctdb/config/ctdb.service $(DESTDIR)/lib/systemd/system/
	# Services fixups
	mv $(DESTDIR)/lib/systemd/system/nmb.service $(DESTDIR)/lib/systemd/system/nmbd.service
	mv $(DESTDIR)/lib/systemd/system/smb.service $(DESTDIR)/lib/systemd/system/smbd.service
	mv $(DESTDIR)/lib/systemd/system/samba.service $(DESTDIR)/lib/systemd/system/samba-ad-dc.service
	sed -i \
	  -e 's|/etc/sysconfig/|/etc/default/|' \
	  -e 's|nmb\.service|nmbd.service|' \
	  -e 's|smb\.service|smbd.service|' \
	  -e 's|samba\.service|samba-ad-dc.service|' \
	  $(DESTDIR)/lib/systemd/system/nmbd.service \
	  $(DESTDIR)/lib/systemd/system/samba-ad-dc.service \
	  $(DESTDIR)/lib/systemd/system/smbd.service \
	  $(DESTDIR)/lib/systemd/system/winbind.service
endif
	# Harmless on systems without systemd-tmpfiles, and other consumers exist
	# such as OpenRC's opentmpfiles
	mkdir -p $(DESTDIR)/usr/lib/tmpfiles.d
	echo "d /run/samba 0755 root root -" > $(DESTDIR)/usr/lib/tmpfiles.d/samba.conf
	echo "d /run/ctdb 0755 root root -" > $(DESTDIR)/usr/lib/tmpfiles.d/ctdb.conf

override_dh_installdocs-arch:

=== debian/tests/control ===
Tests: cifs-share-access
Depends: samba, coreutils, systemd, cifs-utils, passwd
Restrictions: needs-root, allow-stderr, isolation-machine

Tests: python-smoke
Depends: python3-samba

Tests: smbclient-anonymous-share-list
Depends: samba, smbclient
Restrictions: allow-stderr, isolation-container

Tests: smbclient-authenticated-share-list
Depends: samba, smbclient, passwd
Restrictions: needs-root, allow-stderr, isolation-container

Tests: smbclient-share-access
Depends: samba, smbclient, coreutils, systemd, passwd
Restrictions: needs-root, allow-stderr, isolation-container

Tests: reinstall-samba-common-bin
Depends: samba-common, samba-common-bin
Restrictions: needs-root, needs-reboot, isolation-machine, allow-stderr

Tests: samba-ad-dc-provisioning-internal-dns
Depends: samba, samba-dsdb-modules, samba-vfs-modules, winbind, smbclient, krb5-user, bind9-dnsutils, lxd | snapd, lsb-release, dctrl-tools
Restrictions: needs-root, isolation-machine, allow-stderr, breaks-testbed
